#!/usr/bin/env python
# -*- coding: utf-8 -*-



def logLineSplit(line, whitechar=' ', fieldDelimiters={'"':'"', '[':']'}):
    """This function splits a line into tokens using the specified white
       character and the field delimiters"""
    retVal = []
    openingDelimiters = fieldDelimiters.keys()
    tokens = line.split(whitechar)
    incompleteToken = ''
    closingDelimiter = ''
    for token in tokens:
        if closingDelimiter:
            if token[-1:] == closingDelimiter:
                closingDelimiter = ''
                retVal.append(incompleteToken + whitechar + token)
            else:
                incompleteToken = incompleteToken + whitechar + token
        else:
            if token[0] in openingDelimiters:
                closingDelimiter = fieldDelimiters[token[0]]
                if token[-1:] == closingDelimiter:
                    retVal.append(token)
                    closingDelimiter = ''
                else:
                    incompleteToken = token
            else:
                retVal.append(token)

    return retVal
