# See also:
#   http://labix.org/snippets/permutations
#   http://gniemeyer.livejournal.com/9116.html
#   http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/474124
#   http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/496724

__all__ = [
  'combinations', 'uniqueCombinations', 'selections', 'permutations', 'tree'
]

def combinations(items, n):
    if n==0: yield []
    else:
        for i in xrange(len(items)):
            for cc in combinations(items[:i]+items[i+1:],n-1):
                yield [items[i]]+cc

def uniqueCombinations(items, n):
    if n==0: yield []
    else:
        for i in xrange(len(items)):
            for cc in uniqueCombinations(items[i+1:],n-1):
                yield [items[i]]+cc


def selections(items, n):
    if n==0: yield []
    else:
        for i in xrange(len(items)):
            for ss in selections(items, n-1):
                yield [items[i]]+ss


def permutations(items):
    return combinations(items, len(items))



def tree (branch, depth=None) :
    if depth is None :
        depth = len(branch)
    for i in xrange(1, depth+1) :
        for s in selections(branch, i) :
            yield s

if __name__ == '__main__' :

    for n in tree(range(3), 4) :
        print n

    print
    for p in permutations(range(1,6)) :
        print p
