#!/usr/bin/env python
# -*- coding: ISO-8859-2 -*-

import re, sys
import smtplib
if sys.version_info >= (2,5):
    from email.mime.text import MIMEText
    from email.mime.multipart import MIMEMultipart
    from email.header import Header
    from email.message import Message
else:
    from email.MIMEText import MIMEText
    from email.MIMEMultipart import MIMEMultipart
    from email.Header import Header
    from email.Message import Message


EMAIL_REGEX = re.compile('^[-+a-zA-Z_0-9.]+@[^\.]+[-a-zA-Z_0-9\.]+$')


def sendMail(sender, recipients, subject, body, **kw):
    '''funkce odesle mail
            sender: email odesilatele
            recipients: seznam emailu adresatu
            body: string, nebo uz pripravena email.Message
            kw:
                charset: charset tela zpravy a subjektu
                debug: adresa, ktera se pouzije misto prijemcu
                server: pres ktery SMTP server se posila
    '''
    if not EMAIL_REGEX.match(sender or ''):
        raise ValueError, 'Incorrect sender address: %s' % sender

    if isinstance(recipients, basestring):
        rcpts = [recipients,]
    elif type(recipients) is not list:
        rcpts = list(recipients)
    else:
        rcpts = recipients
    rcpts = [r for r in rcpts if EMAIL_REGEX.match(r or '')]
    if not rcpts:
        raise ValueError, 'Incorrect recipients addresses: %s' % recipients

    if type(body) in (str, unicode):
        outer = MIMEText(body, _charset=kw.get('charset', 'iso-8859-2'))
        outer['Subject'] = Header(subject, kw.get('charset', 'iso-8859-2'))
        outer['From'] = sender
        outer['To'] = ', '.join(rcpts)
        outer.epilogue = ''
    elif isinstance(body, Message):
        outer = body
    else:
        raise ValueError, 'Incorrect body of email: %s' % body

    if kw.get('debug', None):
        recipients = [kw['debug'],]

    server = smtplib.SMTP(kw.get('server', 'localhost'))
    server.sendmail(sender, recipients, outer.as_string())
    server.quit()
