import unittest
from lib4.cache import *
from itertools import count

class LRUCache(LRUCache):

    _stamp = count().next


class TestLRUCache(unittest.TestCase):

    def test10_AddToEmpty(self):
        lru = LRUCache()
        lru[1] = 'a'
        self.assertEqual(len(lru), 1)
        self.assertEqual(lru[1], 'a')
        self.assertRaises(KeyError, lru.__getitem__, 2)

    def test11_AddToNonEmpty(self):
        lru = LRUCache()
        lru[1] = 'a'
        lru[2] = 'b'
        self.assertEqual(len(lru), 2)
        self.assertEqual(lru[1], 'a')
        self.assertEqual(lru[2], 'b')

    def test11_AddToFull(self):
        lru = LRUCache(1)
        lru[1] = 'a'
        lru[2] = 'b'
        self.assertEqual(len(lru), 1)
        self.assertRaises(KeyError, lru.__getitem__, 1)
        self.assertEqual(lru[2], 'b')

    def test20_AccessPattern(self):
        lru = LRUCache(2)
        lru[1] = 'a'
        lru[2] = 'b'
        lru[3] = 'c'
        self.assertEqual(len(lru), 2)
        self.assertRaises(KeyError, lru.__getitem__, 1)
        self.assertEqual(lru[2], 'b')
        self.assertEqual(lru[3], 'c')

    def test21_AccessPattern(self):
        lru = LRUCache(2)
        lru[1] = 'a'
        lru[2] = 'b'
        lru[1]
        lru[3] = 'c'
        self.assertEqual(len(lru), 2)
        self.assertEqual(lru[1], 'a')
        self.assertRaises(KeyError, lru.__getitem__, 2)
        self.assertEqual(lru[3], 'c')

    def test22_AccessPattern(self):
        lru = LRUCache(2)
        lru[1] = 'a'
        lru[2] = 'b'
        lru[1] = 'A'
        lru[3] = 'c'
        self.assertEqual(len(lru), 2)
        self.assertEqual(lru[1], 'A')
        self.assertRaises(KeyError, lru.__getitem__, 2)
        self.assertEqual(lru[3], 'c')
