import unittest
import os
from lib4.content_types import magicService

THIS_DIR = os.path.dirname(__file__)

def imgFile(name):
    return os.path.join(THIS_DIR, 'imgs', name)


class TestMagic(unittest.TestCase):

    def setUp(self):
        self.magic = magicService()

    def test10_JPG(self):
        fn = imgFile('mlynek.jpg')
        self.assertEqual(self.magic.file(fn), 'image/jpeg')
        bf = open(fn).read(1024)
        self.assertEqual(self.magic.buffer(bf), 'image/jpeg')
        fn = imgFile('p.jpeg')
        self.assertEqual(self.magic.file(fn), 'image/jpeg')
        bf = open(fn).read(1024)
        self.assertEqual(self.magic.buffer(bf), 'image/jpeg')

    def test11_TIFF(self):
        fn = imgFile('sovabg.tiff')
        self.assertEqual(self.magic.file(fn), 'image/tiff')
        bf = open(fn).read(1024)
        self.assertEqual(self.magic.buffer(bf), 'image/tiff')

    def test12_BMP(self):
        fn = imgFile('b.bmp')
        self.assertEqual(self.magic.file(fn), 'image/x-ms-bmp')
        bf = open(fn).read(1024)
        self.assertEqual(self.magic.buffer(bf), 'image/x-ms-bmp')

    def test13_PNG(self):
        fn = imgFile('p.png')
        self.assertEqual(self.magic.file(fn), 'image/png')
        bf = open(fn).read(1024)
        self.assertEqual(self.magic.buffer(bf), 'image/png')

    def test20_Word(self):
        fn = os.path.join(THIS_DIR, 'samples', 'stanovy.doc')
        self.assertEqual(self.magic.file(fn), 'application/msword')
        bf = open(fn).read(1024)
        self.assertEqual(self.magic.buffer(bf), 'application/msword')
        fn = os.path.join(THIS_DIR, 'samples', 'masqueraded_word')
        self.assertEqual(self.magic.file(fn), 'application/msword')
        bf = open(fn).read(1024)
        self.assertEqual(self.magic.buffer(bf), 'application/msword')

